/***************************************************************************
 *   Copyright (C) 2005 by Emiliano Gulmini                                *
 *   emi_barbarossa@yahoo.it                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
//QT Headers
#include <qspinbox.h>
#include <qtabwidget.h>
#include <qwidgetstack.h>
#include <qcolor.h>

//KDE Headers
#include <kconfig.h>

//Local Headers
#include "configuration.h"
#include "globaltypes.h"

using namespace Global;
Configuration::Configuration(KConfig* config)
{
  m_config = config;
}


Configuration::~Configuration()
{
}

/*!
    \fn Configuration::slotColor(const QColor& c, const Global::ColorType& t)
 */
void Configuration::setColor(const QColor& c, const ColorType& t)
{
  switch(t)
    {
      case numbers:{ m_colorNumbers = QString::number(c.red(),10) + "," +
                     QString::number(c.green(),10) + "," +
                     QString::number(c.blue(),10); } break;

      case operations:{ m_colorOperations = QString::number(c.red(),10) + "," +
                        QString::number(c.green(),10) + "," +
                        QString::number(c.blue(),10); } break;

      case functions:{ m_colorFunctions = QString::number(c.red(),10) + "," +
                       QString::number(c.green(),10) + "," +
                       QString::number(c.blue(),10); } break;

      case keywords:{ m_colorKeywords = QString::number(c.red(),10) + "," +
                      QString::number(c.green(),10) + "," +
                      QString::number(c.blue(),10); } break;

      case specials:{ m_colorSpecials = QString::number(c.red(),10) + "," +
                      QString::number(c.green(),10) + "," +
                      QString::number(c.blue(),10); } break;
    }
}

/*!
    \fn Configuration::color(const ColorType& t) const
*/
QString Configuration::color(const ColorType& t) const
{ 
  switch(t)
    {
      case numbers: return m_colorNumbers;
      case operations: return m_colorOperations;
      case functions: return m_colorFunctions;
      case keywords: return m_colorKeywords;
      case specials: return m_colorSpecials;
      default: return QString::null;
    }
}

/*!
    \fn Configuration::setBCPath(const QString& path)
 */
void Configuration::setBCPath(const QString& path)
{
  m_bcPath = path;
}

/*!
    \fn Configuration::setPythonModulesPath(const QString& path)
 */
void Configuration::setPythonModulesPath(const QString& path)
{
  m_pythonModulesPath = path;
}

/*!
    \fn Configuration::setEnableLogFile(bool checked)
 */
void Configuration::setEnableLogFile(bool checked)
{
  m_enableLogFile = checked;
}

/*!
    \fn Configuration::setLogFilePath(const QString& path)
 */
void Configuration::setLogFilePath(const QString& path)
{
  m_logFilePath = path;
}
