/***************************************************************************
 *   Copyright (C) 2005 by Emiliano Gulmini                                *
 *   emi_barbarossa@yahoo.it                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CONFIGURATION_H
#define CONFIGURATION_H

//QT Headers
#include <qstring.h>
class QColor;

//KDE Headers
class KConfig;

//Local Headers
#include "globaltypes.h"


/**
 * @short This class handles settings in the configuration tab page
 * @author Emiliano Gulmini <emi_barbarossa@yahoo.it>
 */
class Configuration
{
  KConfig* m_config;
  QString m_scale,
          m_ibase,
          m_obase;
  QString m_font;
  QString m_colorNumbers,
          m_colorOperations,
          m_colorFunctions,
          m_colorKeywords,
          m_colorSpecials;
  QString m_bcPath,
          m_pythonModulesPath,
          m_logFilePath;
  QString m_pyDecimalDigits;
  bool m_enableLogFile;
  public:
    Configuration(KConfig* config);

    ~Configuration();
  public:
    QString scale() const { return m_scale; }
    void setScale(const QString& s) { m_scale = s; }

    QString ibase() const { return m_ibase; }
    void setIBase(const QString& s) { m_ibase = s; }

    QString obase() const { return m_obase; }
    void setOBase(const QString& s) { m_obase = s; }

    QString font() const { return m_font; }
    void setFont(const QString& f) { m_font = f; }

    void setColor(const QColor& c, const Global::ColorType& t);
    QString color(const Global::ColorType& t) const ;

    QString bcPath() const { return m_bcPath; }
    void setBCPath(const QString& path);

    QString pythonModulesPath() const { return m_pythonModulesPath; }
    void setPythonModulesPath(const QString& path);

    bool enableLogFile() const { return m_enableLogFile; }
    void setEnableLogFile(bool checked);

    QString logFilePath() const { return m_logFilePath; }
    void setLogFilePath(const QString& path);

    QString pythonDecimalDigits() const { return m_pyDecimalDigits; }
    void setPythonDecimalDigits(const QString& s) { m_pyDecimalDigits = s; }
};

#endif
