/***************************************************************************
 *   Copyright (C) 2005 by Emiliano Gulmini   *
 *   emi_barbarossa@yahoo.it   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef PYTHONCODEGENERATOR_H
#define PYTHONCODEGENERATOR_H

#include <qobject.h>

//Local headers
#include "globaltypes.h"
/**
 * This class creates the python code used internally by kalcoolus to manage complex numbers.
 *
 * @author Emiliano Gulmini
 */
class PythonCodeGenerator : public QObject
{
  Q_OBJECT
  public:
    PythonCodeGenerator(QObject *parent = 0, const char *name = 0);

    ~PythonCodeGenerator();
    /**
     * Makes kalcoolus expressions readable for Python interpreter
     */
    static void convertToPython(QString& expression, Global::FunctionsCodeMap fm, Global::ConstantsMap cm);
    /**
     * Converts Python code to kalcoolus notations
     */
    static void convertToKalcoolus(QString& expression);
    static void formatResultString(QString& result, QString& resultBuffer, int internalScriptNumberOfLines);

};

#endif
